﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Websocket Class: littlecrane.bas
' 
Sub Class_Globals
	Private ws As WebSocket
	Private btncraneup As JQueryElement			'Put the crane up
	Private btncranedown As JQueryElement		'Put the crane down
	Private btncraneupmax As JQueryElement		'Put the crane up to max pos
	Private btncranedownmin As JQueryElement	'Put the crane down to min pos
	Private talogging As JQueryElement			'TextArea for logging
	Public	lblcraneangle As JQueryElement		'Keep the current crane position
End Sub

Public Sub Initialize
	
End Sub

' The user opens via browser <URL>:51042. The html file index.html is displayed.
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("WebSocket_Connected :: Start")
	ws = WebSocket1
	Main.ConnectedBrowsers.Put(Me, "")
	talogging.SetText("Enjoy playing with the Crane" & CRLF)
	Log("WebSocket_Connected :: End")
End Sub

'Relesae the connected browsers
Private Sub WebSocket_Disconnected
	Main.ConnectedBrowsers.Remove(Me)
End Sub

#Region CRANEMOVES
Sub btnCraneUp_Click(params As Map)
	SetCranePosition(Main.ServoArmAngle + Main.ServoArmAngleMove)
End Sub

Sub btnCraneDown_Click(params As Map)
	SetCranePosition(Main.ServoArmAngle - Main.ServoArmAngleMove)
End Sub

Sub btnCraneUpMax_Click(params As Map)
	SetCranePosition(Main.ServoArmAngleMax)
End Sub

Sub btnCraneDownMin_Click(params As Map)
	SetCranePosition(Main.ServoArmAngleMin)
End Sub
#End Region

#Region CRANEPOSITION
Sub btnCranePosition_Click(params As Map)
	'Request the servo arm position
	Main.AStream_WriteData(1, 0, 1)
End Sub

'Set the new crane position. 
'First check if position is in range.
'Then write new position to the Arduino. The Arduino will come back with the position set (see Main Sub NewData).
Public Sub SetCranePosition(newpos As Int)
	Log($"B4J:Set New Pos=${newpos}"$)
	If newpos < Main.ServoArmAngleMin Then newpos = Main.ServoArmAngleMin
	If newpos > Main.ServoArmAngleMax Then newpos = Main.ServoArmAngleMax
	'Write the new position to the Arduino:
	'Byte 0 = ServoMotor ID, 1 = new position, 2 = 0 as not requesting but setting position
	Main.AStream_WriteData(1, newpos, 0)
	'Update textarea logging
	Dim s As String = talogging.GetText.Value
	s = $"${DateTime.Time(DateTime.Now)}=${newpos}${CRLF}"$ & s
	talogging.SetText(s)
End Sub

'Update the label in the brwoser. This is triggered by Main Sub NewData.
Public Sub UpdateCranePosition
	Log($"B4J:UpdateCranePosition:${Main.ServoArmAngle}"$)
	lblcraneangle.SetText(Main.ServoArmAngle)
	ws.Flush
End Sub
#End Region
